Index: sfxge_tx.c
===================================================================
--- sfxge_tx.c	(revision 263296)
+++ sfxge_tx.c	(working copy)
@@ -498,7 +498,6 @@ int
 sfxge_tx_packet_add(struct sfxge_txq *txq, struct mbuf *m)
 {
 	int locked;
-	int rc;
 
 	/*
 	 * Try to grab the txq lock.  If we are able to get the lock,
@@ -511,10 +510,9 @@ sfxge_tx_packet_add(struct sfxge_txq *txq, struct
 	 * Can only fail if we weren't able to get the lock.
 	 */
 	if (sfxge_tx_qdpl_put(txq, m, locked) != 0) {
-		KASSERT(!locked,
-		    ("sfxge_tx_qdpl_put() failed locked"));
-		rc = ENOBUFS;
-		goto fail;
+		KASSERT(!locked, ("sfxge_tx_qdpl_put() failed locked"));
+		m_freem(m);
+		return (ENOBUFS);
 	}
 
 	/*
@@ -534,10 +532,6 @@ sfxge_tx_packet_add(struct sfxge_txq *txq, struct
 	}
 
 	return (0);
-
-fail:
-	return (rc);
-	
 }
 
 static void
